(**************************************************************************)
(*                                                                        *)
(*                               GlSurf                                   *)
(*                                                                        *)
(*                   C. Raffalli, Universite de Savoie                    *)
(*                                                                        *)
(* Copyright 2003, 2004 Christohe Raffalli                                *)
(*                                                                        *)
(*  This file is part of GlSurf.                                          *)
(*                                                                        *)
(*  GlSurf is free software; you can redistribute it and/or modify        *)
(*  it under the terms of the GNU General Public License as published by  *)
(*  the Free Software Foundation; either version 2 of the License, or     *)
(*  (at your option) any later version.                                   *)
(*                                                                        *)
(*  GlSurf is distributed in the hope that it will be useful,             *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU General Public License for more details.                          *)
(*                                                                        *) 
(*  You should have received a copy of the GNU General Public License     *)
(*  along with GlSurf; if not, write to the Free Software                 *)
(*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *)
(*  MA  02111-1307  USA                                                   *)
(**************************************************************************)

val parse_spaces : char Stream.t -> unit
val parse_int : char Stream.t -> int
val parse_big_int : char Stream.t -> Big_int.big_int
val parse_float : char Stream.t -> float 
val parse_num : char Stream.t -> Num.num    
val parse_ident : char Stream.t -> string

val parse_delim :
  char -> char -> (char Stream.t -> 'a) -> char Stream.t -> 'a
val parse_tuple :
  (char Stream.t -> 'a) -> (char Stream.t -> 'b) -> char Stream.t -> 'a * 'b
val parse_complex : 'a -> ('a -> 'a) -> 
  (char Stream.t -> 'a) -> char Stream.t -> 'a * 'a
val parse_string :
    char Stream.t -> string
val parse_bool :
    char Stream.t -> bool

val prompt : string ref
val interactive : bool ref
val line_number : int ref
