(**************************************************************************)
(*                                                                        *)
(*                               GlSurf                                   *)
(*                                                                        *)
(*                   C. Raffalli, Universite de Savoie                    *)
(*                                                                        *)
(* Copyright 2003, 2004 Christohe Raffalli                                *)
(*                                                                        *)
(*  This file is part of GlSurf.                                          *)
(*                                                                        *)
(*  GlSurf is free software; you can redistribute it and/or modify        *)
(*  it under the terms of the GNU General Public License as published by  *)
(*  the Free Software Foundation; either version 2 of the License, or     *)
(*  (at your option) any later version.                                   *)
(*                                                                        *)
(*  GlSurf is distributed in the hope that it will be useful,             *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU General Public License for more details.                          *)
(*                                                                        *) 
(*  You should have received a copy of the GNU General Public License     *)
(*  along with GlSurf; if not, write to the Free Software                 *)
(*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *)
(*  MA  02111-1307  USA                                                   *)
(**************************************************************************)

open Vect3

let compute_matrix_coef (order : int) =
  (* 
     on suppose f'(x), f''(x) ... f^(order)(x) connu
     ainsi que  f'(x+h). 
     on veut calculer f''(x+h) ... f^(order)(x+h).
  *)
  let m = Array.make_matrix (2*order) (order-1) 0.0 in
  for i = 0 to order-2 do
    let v1 = Array.make (order+1) 0.0 in
    let v2 = Array.make (order+1) 0.0 in
    (* f'(x+h) - f'(x)= v1 | h*f''(x) ... h^order*f^(order+1)(x) *)
    (* f'(x+h) - f'(x)= v2 | h*f''(x+h) ... h^order(f^(i+2)(x+h)) h^order(f^(i+3)(x)) 
                                        ... h^order*f^(order+1)(x) *)
    let x = ref 1.0 and y = ref 1.0 in
    for j = 1 to order do (* j -> coef de f^(j+1) *)
      x := !x /. j;
      y := -. !y;
      v1.(j) <- !x;
      v2.(j) <- !y*!x;
    done;
    for j = i+1 to order - 1 do
      let x = ref v2.(j) in
      for k = j+1 to order do
	x := !x /. (k -. j);
	v2.(k) <- v2.(k) +. !x; 
      done
    done;
    let l1 = v1.(order) and l2 = v2.(order) in
    m.(i).(0) = 
  done;
  m
